﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;
using Infragistics.Web.UI.ListControls;
using System.Collections;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            DropDownProvider provider = new DropDownProvider();
            provider.ID = "dropdown1";
            provider.EditorControl.DropDownContainerWidth = 150;
            WebDataGrid1.EditorProviders.Add(provider);

            //Could Use the DataSource as well
            ArrayList myAL = new ArrayList();
            myAL.Add("Hello");
            myAL.Add("World");

            //Creating WebDropDown and adding Items From Code Behind 
            WebDropDown DD = new WebDropDown();

            //Could Use the DataSource as well
            //DD.DataSource = myAL;
            DD.ID = "CodeBehindDD";
            DD.Width = 200;
            DD.Items.Add(new DropDownItem() { Text = "CodeBehindDD", Value = "1" });
            DD.Items.Add(new DropDownItem() { Text = "CodeBehindDD Text", Value = "2" });
            DD.Items.Add(new DropDownItem() { Text = "CodeBehindDD More Text", Value = "3" });
            this.form1.Controls.Add(DD);

            //adding Items From Code Behind to WebDropDown created in Markup with ID= WebDropDown1
            WebDropDown1.Items.Add(new DropDownItem() { Text = "Some Text", Value = "1"});
            WebDropDown1.Items.Add(new DropDownItem() { Text = "Some Other Text", Value = "2" });
            WebDropDown1.Items.Add(new DropDownItem() { Text = "Some More Text", Value = "3" });
        }
        
       //((DropDownProvider) WebDataGrid1.EditorProviders["dropdown1"]).EditorControl.DataSource = populateGrid();
       //((DropDownProvider) WebDataGrid1.EditorProviders["dropdown1"]).EditorControl.TextField = "Name";

        //Manualy addint DropDownItems to the DropDown collection
        DropDownProvider DropDownInstance = (DropDownProvider)WebDataGrid1.EditorProviders["dropdown1"];
        for (int i = 0; i < 10; i++)
        {
            Infragistics.Web.UI.ListControls.DropDownItem item = new Infragistics.Web.UI.ListControls.DropDownItem();
            item.Text = "TestItem" + i.ToString();
            item.Value = "TestValue" + i.ToString();
            DropDownInstance.EditorControl.Items.Add(item);
        }

        WebDataGrid1.DataSource = populateGrid();
        WebDataGrid1.DataBind();
    }


    //use to populate our WebDataGrid (and DropdownProvider for simplicity)
    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }
    protected void WebDataGrid1_Init(object sender, EventArgs e)
    {
        //create an unbound column to associate the dropdown provider with (can be a bounddatafield if needed)
        UnboundField column = new UnboundField();
        column.Key = "dropdownCol";
        column.Header.Text = "Dropdown Column";

        //instantiate an editing core
        EditingCore core = new EditingCore();
        core.Enabled = true;
        core.AutoCRUD = false;

        CellEditing editing = new CellEditing();
        core.Behaviors.Add(editing);

        //create the column setting for the Dropdown Column
        EditingColumnSetting setting = new EditingColumnSetting();
        setting.ColumnKey = "dropdownCol";
        setting.EditorID = "dropdown1";

        editing.ColumnSettings.Add(setting);


        WebDataGrid1.Columns.Add(column);
        WebDataGrid1.Behaviors.Add(core);
    }

}